// This file was generated by gir (https://github.com/gtk-rs/gir)
// from
// from gir-files (https://github.com/gtk-rs/gir-files)
// DO NOT EDIT

use crate::{ffi, Auth};
use glib::{prelude::*, translate::*};

glib::wrapper! {
    #[doc(alias = "SoupAuthNegotiate")]
    pub struct AuthNegotiate(Object<ffi::SoupAuthNegotiate>) @extends Auth;

    match fn {
        type_ => || ffi::soup_auth_negotiate_get_type(),
    }
}

impl AuthNegotiate {
    // rustdoc-stripper-ignore-next
    /// Creates a new builder-pattern struct instance to construct [`AuthNegotiate`] objects.
    ///
    /// This method returns an instance of [`AuthNegotiateBuilder`](crate::builders::AuthNegotiateBuilder) which can be used to create [`AuthNegotiate`] objects.
    pub fn builder() -> AuthNegotiateBuilder {
        AuthNegotiateBuilder::new()
    }

    #[doc(alias = "soup_auth_negotiate_supported")]
    pub fn supported() -> bool {
        assert_initialized_main_thread!();
        unsafe { from_glib(ffi::soup_auth_negotiate_supported()) }
    }
}

// rustdoc-stripper-ignore-next
/// A [builder-pattern] type to construct [`AuthNegotiate`] objects.
///
/// [builder-pattern]: https://doc.rust-lang.org/1.0.0/style/ownership/builders.html
#[must_use = "The builder must be built to be used"]
pub struct AuthNegotiateBuilder {
    builder: glib::object::ObjectBuilder<'static, AuthNegotiate>,
}

impl AuthNegotiateBuilder {
    fn new() -> Self {
        Self {
            builder: glib::object::Object::builder(),
        }
    }

    pub fn authority(self, authority: impl Into<glib::GString>) -> Self {
        Self {
            builder: self.builder.property("authority", authority.into()),
        }
    }

    pub fn is_for_proxy(self, is_for_proxy: bool) -> Self {
        Self {
            builder: self.builder.property("is-for-proxy", is_for_proxy),
        }
    }

    pub fn realm(self, realm: impl Into<glib::GString>) -> Self {
        Self {
            builder: self.builder.property("realm", realm.into()),
        }
    }

    // rustdoc-stripper-ignore-next
    /// Build the [`AuthNegotiate`].
    #[must_use = "Building the object from the builder is usually expensive and is not expected to have side effects"]
    pub fn build(self) -> AuthNegotiate {
        self.builder.build()
    }
}
